unit ufarbmischung;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, Buttons;

type

  { Tffarbmischung }

  Tffarbmischung = class(TForm)
    BitBtn1: TBitBtn;
    bzurueck: TButton;
    b_mischfarbe: TButton;
    e_mischfarbe: TEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    l_tuerkis: TLabel;
    l_magenta: TLabel;
    l_gelb: TLabel;
    l_blau: TLabel;
    l_gruen: TLabel;
    l_rot: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    procedure bzurueckClick(Sender: TObject);
    procedure b_mischfarbeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Shape1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape5MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Shape6MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  ffarbmischung: Tffarbmischung;
  rot,gruen,blau,gelb,magenta,tuerkis : BYTE;

implementation

{$R *.lfm}

{ Tffarbmischung }

procedure Tffarbmischung.Shape1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //
  l_rot.Caption:='geklickt'; rot:=100;
end;

procedure Tffarbmischung.FormCreate(Sender: TObject);
VAR i : BYTE;
begin
  // Initialisierung
  rot:=0; gruen:=0; blau:=0; gelb:=0; magenta:=0; tuerkis:=0;
end;

procedure Tffarbmischung.b_mischfarbeClick(Sender: TObject);
VAR mischfarbe : STRING;

 PROCEDURE Farbmischung(f1,f2,f3,f4,f5,f6 : BYTE; VAR mfarbe : STRING);
 VAR mischf : BYTE;
 BEGIN
  //
  mischf := f1 + f2 + f3 + f4 + f5 + f6;
  CASE mischf OF
   110 : mfarbe := 'gelb';
   101 : mfarbe := 'magenta';
   11  : mfarbe := 'türkis';
   111 : mfarbe := 'weiß';
  ELSE mfarbe := 'ungültig';
  END;
 END;



begin
 //Wertuebergabe
 //Farbeingabe erfolgt durch Klicken auf ein Farbshape, dabei wird im ARRAY Farbe[]
 //die jeweilige Komponente auf 1 gesetzt

 //Verarbeitung
 Farbmischung(rot,gruen,blau,gelb,magenta,tuerkis,mischfarbe);

 //Ausgabe
  e_mischfarbe.text:=mischfarbe;
end;

procedure Tffarbmischung.bzurueckClick(Sender: TObject);
begin
 // Initialisierung
  rot:=0; gruen:=0; blau:=0; gelb:=0; magenta:=0; tuerkis:=0;
  e_mischfarbe.text:='-';
  l_rot.Caption:='rot';
  l_gruen.Caption:='grün';
  l_blau.Caption:='blau';
  l_gelb.Caption:='gelb';
  l_magenta.Caption:='magenta';
  l_tuerkis.Caption:='tuerkis';
end;

procedure Tffarbmischung.Shape2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //
  l_gruen.Caption:='geklickt'; gruen:=10;
end;

procedure Tffarbmischung.Shape3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //
  l_blau.Caption:='geklickt'; blau:=1;
end;

procedure Tffarbmischung.Shape4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 //
  l_gelb.Caption:='geklickt'; gelb:=110;
end;

procedure Tffarbmischung.Shape5MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //
  l_magenta.Caption:='geklickt'; magenta:=101;
end;

procedure Tffarbmischung.Shape6MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //
  l_tuerkis.Caption:='geklickt'; tuerkis:=11;
end;

end.

